﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace DragFromGridToAnotherForm
{
    public partial class RadGrid : Telerik.WinControls.UI.RadForm
    {
        public RadGrid()
        {
            InitializeComponent();
        }

        private void RadGrid_Load(object sender, EventArgs e)
        {
            radGridView1.Rows.Add(new object[] { "row1-col1", "row1-col2" });
            radGridView1.Rows.Add(new object[] { "row2-col1", "row2-col2" });
            radGridView1.Rows.Add(new object[] { "row3-col1", "row3-col2" });
            radGridView1.Rows.Add(new object[] { "row4-col1", "row4-col2" });

            //register the custom row behavior
            BaseGridBehavior gridBehavior = radGridView1.GridBehavior as BaseGridBehavior;
            gridBehavior.UnregisterBehavior(typeof(GridViewDataRowInfo));
            gridBehavior.RegisterBehavior(typeof(GridViewDataRowInfo), new CustomRowGridBehavior());

            ////handle drag and drop events for the grid through the DragDrop service
            RadDragDropService svc = this.radGridView1.GridViewElement.GetService<RadDragDropService>();
            svc.PreviewDragStart += svc_PreviewDragStart;
            svc.PreviewDragDrop += svc_PreviewDragDrop;
            svc.PreviewDragOver += svc_PreviewDragOver;
        }

        private void svc_PreviewDragStart(object sender, PreviewDragStartEventArgs e)
        {
            e.CanStart = true;

        }

        private void svc_PreviewDragOver(object sender, RadDragOverEventArgs e)
        {
            e.CanDrop = true;

            //if (e.DragInstance is GridDataRowElement)
            //{
            //    if (e.HitTarget is SimpleListViewVisualItem ||
            //        e.HitTarget is SimpleListViewElement)
            //    {
            //        e.CanDrop = true;
            //    }
            //    else
            //    {
            //        e.CanDrop = false;
            //    }

            //}
        }

        private void svc_PreviewDragDrop(object sender, RadDropEventArgs e)
        {



        }
    }

    public class CustomRowGridBehavior : GridDataRowBehavior
    {
        protected override bool OnMouseDownLeft(MouseEventArgs e)
        {
            GridDataRowElement row = this.GetRowAtPoint(e.Location) as GridDataRowElement;

            if (row != null)
            {
                row.Tag = "tag";
                RadGridViewDragDropService svc = this.GridViewElement.GetService<RadGridViewDragDropService>();
                svc.Start(row);

            }
            return base.OnMouseDownLeft(e);
        }
    }
}
